<!--
 * @Author: zhp
 * @Date: 2023-01-11 09:24:58
 * @LastEditTime: 2023-06-20 15:35:25
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="6" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <base-table :table-props="tableProps" :page="listQuery.page" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <laboratoryTrainExperience-add ref="addOrUpdate" @refreshDataList="successSubmit">
        </laboratoryTrainExperience-add>
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <!-- <gage-search ref="searchOrUpdate" @refreshDataList="conditionSearchSubmit"></gage-search> -->
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{ $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import laboratoryTrainExperienceAdd from "./components/laboratoryTrainExperience-add"
// import gageSearch from "./components/gageSearch"
import basicSearch from "@/mixins/basic-search"
import { timeFormatter } from '@/filters'
import i18n from "@/i18n"
const tableProps = [
  {
    prop: 'title',
    label: i18n.t("laboratory.title"),
    align: 'center'
  },
  {
    prop: 'trainContent',
    label: i18n.t("laboratory.trainContent"),
    align: 'center'
  },
  {
    prop: 'result',
    label: i18n.t("laboratory.result"),
    align: 'center'
  },
  {
    prop: 'trainDuration',
    label: i18n.t("laboratory.trainDuration"),
    align: 'center'
  },
  {
    prop: 'trainType',
    label: i18n.t("laboratory.trainType"),
    align: 'center'
  },
  {
    prop: 'trainDate',
    label: i18n.t("laboratory.trainDate"),
    align: 'center',
    filter: timeFormatter,
  },
  
]
const tableBtn = [
  {
    type: "edit",
    btnName: i18n.t("edit"),
  },
  {
    type: "delete",
    btnName: i18n.t("delete"),

  }
];
export default {
  mixins: [basicPage, basicSearch],
  components: {
    // gageSearch,
    laboratoryTrainExperienceAdd
  },
  data() {
    return {
      urlOptions: {
        getDataListURL: "/laboratory/qmsLaboratoryTrainExperience/page",
        deleteURL: "/laboratory/qmsLaboratoryTrainExperience",
        exportUrl: '/laboratory/qmsLaboratoryTrainExperience/export'
      },
      tableProps,
      tableBtn,
      searchOrEditTitle: '',
      searchOrUpdateVisible: false,
      formConfig: [
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: i18n.t('add'),
          name: "add",
          color: "primary",
        },
        {
          type: "button",
          btnName: i18n.t('export'),
          name: "export",
          color: "primary",
        },
        {
          type: "button",
          btnName: i18n.t('search'),
          name: "search",
          color: "primary",
        }
      ],
    };
  },
  // components: {
  //   AddOrUpdate,
  // },
  mounted() {
    if (this.$route.query) {
      console.log(this.$route.query)
      this.listQuery.laboratoryTesterId = this.$route.query.laboratoryTesterId
      this.getDataList()
    }
  },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    conditionSearchSubmit(dataForm) {
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.name}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true;
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init({ id: val.data.id })
        })
      }
    },
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1
          this.getDataList();
          break;
        case "export":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1
          this.exportHandle();
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true;
          this.$nextTick(() => {
            this.$refs.addOrUpdate.init({ laboratoryTesterId: this.$route.query.laboratoryTesterId })
          })
          break;
        default:
          console.log(val)
      }
    },
  }
};
</script>
